//==============================================================
// O[oϐ
//==============================================================
// ϊs
float4x4 mW;		// [hs
float4x4 mV;		// r[s
float4x4 mP;		// ˉes

// }eA֌W
float4	Diffuse = float4(1,1,1,1);	// {F
float	Ambient = 0.3;				// ̋
float4	Specular = float4(1,1,1,1);	// ːF
float	Power = 50;					// ːF̗
texture MeshTex;	// }eÃeNX`
sampler MeshSmp=sampler_state {	// MeshTexpTv
	Texture=<MeshTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

// }bv
texture SphereTex;
sampler SphereSmp=sampler_state {	// SphereTexpTv
	Texture=<SphereTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU = Clamp;
	AddressV = Clamp;
};

float Reflection = 0.7;	// f荞ݗ


// Cgp
float3 LightDir;	// Cg̕

// Jp
float3 CamPos;		// _̈ʒu

//==============================================================
// _VF[_sNZVF[_ɓnf[^p\
//==============================================================
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float2 MeshUV	: TEXCOORD0;	// eNX`UV
	
	float3 wPos		: TEXCOORD1;	// 3DW
	float3 wN		: TEXCOORD2;	// @
};

//==============================================================
// _VF[_
//	E_PĂ̂ŁAsNZVF[_ɓnB
//==============================================================
VS_OUT VS (
	float4 pos : POSITION,				// W
	float3 normal : NORMAL,				// @
	float2 mesh_uv : TEXCOORD0			// eNX`UV
) {
	VS_OUT Out = (VS_OUT)0;		// sNZf[^ɓnf[^p\
	
	// _W
	Out.Pos = mul(pos, mW);
		Out.wPos = Out.Pos.xyz;	// 3DԂł̍WɂȂ
	Out.Pos = mul(Out.Pos, mV);	// 3DJWnł̍WɂȂ
	Out.Pos = mul(Out.Pos, mP);	// 2DԂł̍WɂȂ

	// eNX`W
	Out.MeshUV = mesh_uv;

	// @
	float3 w_normal = normalize(mul(normal, (float3x3)mW));	// [hnɕϊ
	Out.wN = w_normal;

	return Out;
}


//==================================================================
// sNZVF[_
//	EsNZ̐F肵A̐FԂ(R,G,B,Afloat4^)
//==================================================================
float4 PS(VS_OUT In) : COLOR0
{
	// @𐳋K
	float3 w_normal = normalize(In.wN);

	//================================================
	// CeBO(o[g)
	//================================================
	float LPow = max(0, dot(-LightDir, w_normal));	// ̋
	
	//================================================
	// XyL
	//================================================
	float3 vCam = normalize( CamPos - In.wPos );		// (J)ւ̕
	float3 vRef = LightDir + 2.0f * dot( w_normal, -LightDir ) * w_normal;
	float SpePow = pow(max(0,dot(vCam,vRef)), Power);
	float4 Spe = Specular * SpePow;

	//================================================
	// f̐FZo
	//================================================
	// f̐F
	float4 Col = Diffuse * tex2D(MeshSmp, In.MeshUV);
	Col.rgb *= (1-Reflection);	// RGBFɔ䗦

	// wi̐F XtBA}bv
	float3 vSphRef = reflect(-vCam, w_normal);
	float2 SphUV = vSphRef.xy;
	SphUV = SphUV * 0.5 + 0.5;
	SphUV.y = 1 - SphUV.y;
	float4 SphCol = tex2D(SphereSmp, SphUV) * Reflection;
	SphCol.a = 0;	// ͎g

	float4 TCol = Col + SphCol;

	// Cg̓̋+
	TCol.rgb *= min(1, LPow + Ambient);
	
	//================================================
	// Fo
	//================================================
	return TCol + Spe;
}

//==============================================================
// eNjbN
//==============================================================
technique Tech
{
	pass P0 {
		VertexShader=compile vs_3_0 VS();
		PixelShader=compile ps_3_0 PS();
	}
}
