//==============================================================
// O[oϐ
//==============================================================
// ϊs
float4x4 mW;		// [hs
float4x4 mV;		// r[s
float4x4 mP;		// ˉes

// }eA֌W
float4	Diffuse = float4(1,1,1,1);	// {F
float	Ambient = 0.3;				// ̋
float4	Specular = float4(1,1,1,1);	// ːF
float	Power = 50;					// ːF̗
texture MeshTex;	// }eÃeNX`
sampler MeshSmp=sampler_state {	// MeshTexpTv
	Texture=<MeshTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

// VhE}bvp
float4x4 mLVP;	// Cg̃r[s񁖎ˉes
texture ShadowTex;	// VhE}bv([x}bv)
sampler ShadowSmp=sampler_state {
	Texture=<ShadowTex>;
	MipFilter=NONE;
	MinFilter=POINT;
	MagFilter=POINT;
	AddressU = Clamp;
	AddressV = Clamp;
};
int ShadowPixelSize = 1024;	// 摜̃TCY(sNZ)
float Margin = 0.0009;

// Cgp
float3 LightDir;	// Cg̕

// Jp
float3 CamPos;		// _̈ʒu

//==============================================================
// _VF[_sNZVF[_ɓnf[^p\
//==============================================================
struct VS_OUT
{
	float4 Pos		: POSITION;		// 2DW
	float2 MeshUV	: TEXCOORD0;	// eNX`UV
	
	float3 wPos		: TEXCOORD1;	// 3DW
	float3 wN		: TEXCOORD2;	// @
};

//==============================================================
// _VF[_
//	E_PĂ̂ŁAsNZVF[_ɓnB
//==============================================================
VS_OUT VS (
	float4 pos : POSITION,				// W
	float3 normal : NORMAL,				// @
	float2 mesh_uv : TEXCOORD0			// eNX`UV
) {
	VS_OUT Out = (VS_OUT)0;		// sNZf[^ɓnf[^p\
	
	// _W
	Out.Pos = mul(pos, mW);
		Out.wPos = Out.Pos.xyz;	// 3DԂł̍WɂȂ
	Out.Pos = mul(Out.Pos, mV);	// 3DJWnł̍WɂȂ
	Out.Pos = mul(Out.Pos, mP);	// 2DԂł̍WɂȂ

	// eNX`W
	Out.MeshUV = mesh_uv;

	// @
	float3 w_normal = normalize(mul(normal, (float3x3)mW));	// [hnɕϊ
	Out.wN = w_normal;

	return Out;
}


//==================================================================
// sNZVF[_
//	EsNZ̐F肵A̐FԂ(R,G,B,Afloat4^)
//==================================================================
float4 PS(VS_OUT In) : COLOR0
{
	// @𐳋K
	float3 w_normal = normalize(In.wN);

	//================================================
	// CeBO(o[g)
	//================================================
	float LPow = max(0, dot(-LightDir, w_normal));	// ̋

	//================================================
	// VhE}bv
	//================================================
	float4 LiPos = mul(float4(In.wPos,1), mLVP);
	LiPos.xyz = LiPos.xyz / LiPos.w;
	if( abs(LiPos.x) <= 1 && abs(LiPos.y) <= 1 && LiPos.z <= 1){	// eNX` z1ȏ̒leNX`ɓĂȂ̂
		// 2DWneNX`Wnɕϊ
		float2 uv = LiPos.xy*0.5 + 0.5;
		uv.y = 1 - uv.y;

		// Cg邩ǂ𔻒肷
		float z = LiPos.z - Margin;

// 0Ƈ@RpCB0ȊOƇARpCB
#if 0
		//================================================
		// @Pȕ@(ԂȂAKNKNɂȂ)
		float S_Pow = tex2D(ShadowSmp, uv).r < z ? 0 : 1;
		//================================================
#else
		//================================================
		// AȈՃ\tgo[W(KNKNP)
		float ShadowTexelSize = 1.0/ShadowPixelSize;	// 摜̃TCY(eNZ)BVCŌvZĎĂI
		float t0, t1, t2, t3;
		t0=(tex2D(ShadowSmp, uv).r < z) ? 0 : 1;
		t1=(tex2D(ShadowSmp, uv+float2(ShadowTexelSize, 0)) < z).r ? 0 : 1;	// PE
		t2=(tex2D(ShadowSmp, uv+float2(0, ShadowTexelSize)) < z).r ? 0 : 1;	// P
		t3=(tex2D(ShadowSmp, uv+float2(ShadowTexelSize, ShadowTexelSize)).r < z ) ? 0 : 1;	// PE
		// 茋ʂ`Ԃ
		float2 f = frac(uv*ShadowPixelSize);	// sNZWnɕϊÂ݂擾
		float S_Pow = lerp(		// Ԃꂽe̋yŕ
			lerp(t0, t1, f.x),		// 2sNZxŕ
			lerp(t2, t3, f.x),		// 2sNZxŕ
			f.y);
		//================================================
#endif

		LPow = min(LPow,S_Pow);
	}

	
	//================================================
	// XyL
	//================================================
	float3 vCam = normalize( CamPos - In.wPos );		// (J)ւ̕
	float3 vRef = LightDir + 2.0f * dot( w_normal, -LightDir ) * w_normal;
	float SpePow = pow(max(0,dot(vCam,vRef)), Power);
	float4 Spe = Specular * SpePow;

	//================================================
	// fFZo
	//================================================
	// f̐F
	float4 Col = Diffuse * tex2D(MeshSmp, In.MeshUV);
	// Cg̓̋+
	Col.rgb *= min(1, LPow + Ambient);
	
	// eXg
	clip(Col.a - 0.01);

	//================================================
	// Fo
	//================================================
	return Col + Spe;
}

//==============================================================
// eNjbN
//==============================================================
technique Tech
{
	pass P0 {
		VertexShader=compile vs_3_0 VS();
		PixelShader=compile ps_3_0 PS();
	}
}
