//Warning
#pragma warning(disable : 4995)
#pragma warning(disable : 4996)
#pragma warning(disable : 4819)

//
#include <windows.h>

//STL
#include <iostream>
#include <string>
#include <vector>
#include <fstream>
// DirectX֘A
#include<d3dx9.h>
#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")
#pragma comment(lib, "dxguid.lib")
#pragma comment(lib, "winmm.lib")


using namespace std;

/**
@data 2016/03/17
@file MapMaker.cpp
@brief 3DMapMakerpLoad֐ƃf[^^
@author с@z
*/

/*!@name }bv[J[p
MapMakerōt@Cǂݍނ߂̊֐ƃf[^^p
*/
/*@{*/
namespace MapMaker {


	bool isBinaryFile(string _filename)
	{
		//Binaryǂ𔻒肷
		FILE* file = NULL;
		int check;
		file = fopen(_filename.c_str(), "rb");
		if (file == NULL) {
			return false;
		}

		while (0 == feof(file)) {
			check = fgetc(file);
			if (check == EOF) { break; }
			else if (check <= 8) {
				fclose(file);
				file = NULL;
				return true;
			}
		}
		fclose(file);
		file = NULL;
		return false;
	}

	bool LoadMatrixFile(string _filename, D3DXMATRIX* _world)
	{
		ifstream file;
		if (isBinaryFile(_filename)) {
			//Binary
			file.open(_filename, ios_base::binary | ios_base::in);
			if (!file) { return false; }
			file.read((char*)&*_world, sizeof(D3DXMATRIX));
			file.close();
			return true;
		}
		else
		{
			//AXL[t@C
			file.open(_filename);
			if (!file) { return false; }
			string str;
			file >> str;
			size_t cpos;
			cpos = str.find_first_of("()");//ŏMatrix̕ǂ݂
			str.substr(0, cpos);
			str = str.substr(cpos + 1);
			UINT i, j;
			i = j = 0;
			while (str.find_first_of("()") != string::npos) {
				size_t cpos = 0;
				cpos = str.find_first_of(",)");

				if (cpos > 0) {

					_world->m[i][j] = stof(str.substr(0, cpos));
					j++;
					if (j > 3) { i++; j = 0; }
				}
				str = str.substr(cpos + 1);
			}
			file.close();
			return true;
		}

		return false;
	}

	bool LoadMatrixListFile(string _filename, vector<D3DXMATRIX>& _MatList)
	{
		ifstream file;
		if (isBinaryFile(_filename)) {
			//Binary
			file.open(_filename, ios_base::binary | ios_base::in);
			if (!file) { return false; }
			while (1) {
				D3DXMATRIX mw;
				D3DXMatrixIdentity(&mw);
				file.read((char*)&mw, sizeof(D3DXMATRIX));
				if (file.eof()) { break; }
				_MatList.push_back(mw);
			}
			file.close();
			return true;
		}
		else
		{
			//AXL[t@C
			file.open(_filename);
			if (!file) { return false; }
			string str;
			UINT k = 0;
			while (1) {
				file >> str;
				if (file.fail()) { break; }
				D3DXMATRIX mm;
				D3DXMatrixIdentity(&mm);
				_MatList.push_back(mm);
				size_t cpos;
				cpos = str.find_first_of("()");//ŏMatrix̕ǂ݂
				str.substr(0, cpos);
				str = str.substr(cpos + 1);
				UINT i, j;
				i = j = 0;
				while (str.find_first_of("()") != string::npos) {
					size_t cpos = 0;
					cpos = str.find_first_of(",)");

					if (cpos > 0) {

						_MatList[k].m[i][j] = stof(str.substr(0, cpos));
						j++;
						if (j > 3) { i++; j = 0; }
					}
					str = str.substr(cpos + 1);
				}
				k++; //MatrixData
			}
			file.close();
			return true;
		}

		return true;
	}

	bool LoadMapFile(string _filename, vector<MAPDATA>& _MapList)
	{
		ifstream file;
		file.open(_filename);
		if (!file) { return false; }
		string str;
		int k = 0;
		while (1) {
			file >> str;
			if (file.fail()) { break; }
			_MapList.push_back(MAPDATA());
			size_t cpos;

			cpos = str.find_first_of("{");////XFileName(

			str = str.substr(cpos + 1);
			cpos = str.find_first_of("}");
			_MapList[k].name = str.substr(0, cpos);

			str = str.substr(cpos + 1);
			cpos = str.find_first_of("(");//ŏ̕ǂ݂(Matrix)
			str = str.substr(cpos + 1);

			UINT i, j;
			i = j = 0;
			while (str.find_first_of("()") != string::npos) {
				size_t cpos = 0;
				cpos = str.find_first_of(",)");

				if (cpos > 0) {

					_MapList[k].world.m[i][j] = stof(str.substr(0, cpos));
					j++;
					if (j > 3) { i++; j = 0; }
				}
				str = str.substr(cpos + 1);
			}
			k++; //̃f[^
		}
		file.close();


		return true;
	}

};
/*@}*/